<template>

  <div class="home font-sans">
    <Alerta></Alerta>
    <h1
      class="mb-2 text-2xl leading-none tracking-tight text-gray-900 md:text-1xl lg:text-2xl dark:text-gray-500 text-left">
      Listado de colaboradores</h1>
    <div>
      <div class="opciones">
        <p class="font-sans font-semibold border-b">Colaboradores</p>
        <hr />
        <input v-model="semilla" class="icon" type="text" placeholder="Buscar por nombre" @keyup.enter="buscaNombre">
        <button class="button" @click="CrearColaborador">Crear colaborador</button>
      </div>
      <TableComp :Listado="this.colaboradores" :Skip="this.skip" :Total="this.total" :Limite="this.limit"></TableComp>
      <div class="text-right m-7">
         Total colaboradores: {{ this.skip }} de {{ this.total }} 
        <button class="button-tab mr-2" :disabled="!disabledAtras" @click=atras()>Atras</button>
        <button class="button-tab"  @click=siguiente()>Siguiente</button>
      </div>
    </div>

    <Formulario :DatosColaborador="this.DatosItem"></Formulario>
  </div>
</template>

<script>
// @ is an alias to /src
import Formulario from '@/components/FormularioComponent.vue'
import TableComp from '@/components/TableComponent.vue'
import Alerta from '@/components/AlertComponent.vue'
export default {
  name: 'HomeView',
  components: {
    Formulario,
    TableComp,
    Alerta
  },
  mounted() {
    this.allColaboradores();
  },
  data: function () {
    return {
      colaboradores: [{
        id: null,
        age: null,
        firstName: null,
        maidenName: null,
        lastName: null,
        weight: null
      }
      ],
      DatosItem: {
        id: null,
        age: null,
        firstName: null,
        maidenName: null,
        lastName: null,
        weight: null,
      },
      limit: 10,
      skip: 0,
      total: 0,
      opatras: false,
      semilla: '',
      disabledAtras: false
    };
  },
  methods: {
    allColaboradores() {
      var url = `${process.env.VUE_APP_USRAPI}?limit=${this.limit}&skip=${this.skip}`;
      fetch(url)
        .then(response => {
          if (!response.ok) {
            throw new Error('Network response was not ok');
          }
          return response.json();
        })
        .then(data => {
          console.log(data.users)
          this.colaboradores = data.users;
          this.total = data.total;
          this.limit = data.limit;
          this.skip = data.skip;
        })
        .catch(error => {
          console.error('There was a problem with the fetch operation:', error);
        });
    },
    siguiente() {
      if(this.total > 10){
        this.skip += 10;
        this.validaNavegacion();
      }
    },
    atras() {
      this.skip -= 10;
      this.validaNavegacion();
    },
    validaNavegacion() {
      if (this.skip === 0)
        this.disabledAtras = false;
      if (this.skip > 0)
        this.disabledAtras = true;
      this.allColaboradores();
    },
    buscaNombre() {
      console.log("Buscando nombre: " + this.semilla)
      if (this.semilla == '') {
        this.total = 0; this.limit = 10; this.skip = 0;
        this.allColaboradores()
      } else {
        var url = `${process.env.VUE_APP_USRAPI}/search?q=${this.semilla}`;
        fetch(url)
          .then(response => {
            if (!response.ok) {
              throw new Error('Network response was not ok');
            }
            return response.json();
          })
          .then(data => {
            console.log(data.users)
            this.colaboradores = data.users;
            this.total = data.total;
            this.limit = data.limit;
            this.skip = data.skip;
            this.$root.$emit('NotificacionAlert', "Resultados de la busqueda");
          })
          .catch(error => {
            console.error('There was a problem with the fetch operation:', error);
          });
      }
    },
    CrearColaborador(){
      this.$root.$emit('ModalVisible', true)

    }
  }
}
</script>
<style>
table {
  border-collapse: collapse;
  width: 80%;
  background-color: #fff;
  border: 1px solid rgb(131, 128, 128);
  border-radius: 5px 5px 0px 0px !important;
  -moz-border-radius: 5px 5px 0px 0px !important;
  -webkit-border-radius: 5px 5px 0px 0px !important;
  /* box-shadow: 0 0 10px rgba(0, 0, 0, 0.1); */
}

th,
td {
  padding: 15px;
  text-align: left;
  border-bottom: 1px solid #ddd;
}

th {
  background-color: #f2f2f2;
}

tr:hover {
  background-color: #f5f5f5;
}

.opciones {
  margin-top: 40px;
  margin-bottom: 1%;
}

.button {
  background-color: rgb(20, 140, 233);
  color: #fffdfd;
  padding: 8px 32px;
  font-size: 16px;
  border: none;
  float: right;
  margin: 0 auto;
  border-radius: 5px;
}

.button-tab {
  color: #43b8f7;
  padding: 8px 32px;
  font-size: 16px;
  border: none;
  float: center;
  margin: 0 auto;
  border-radius: 5px;
  font-weight: bold;
}

input {
  border: 1px solid #cacaca;
  padding: 7px 32px 7px 24px !important;
  margin-bottom: auto !important;
  font-size: 16px !important;
  border-radius: 5px;
}


.icon {
  padding-left: 25px;
  background: url("https://static.thenounproject.com/png/101791-200.png") no-repeat left;
  background-size: 20px;
}



</style>
